diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/WiimoteHid.h b/Source/Core/Core/Src/HW/WiimoteEmu/WiimoteHid.h
index 751c177..0119cba 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/WiimoteHid.h
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/WiimoteHid.h
@@ -63,14 +63,23 @@ struct wm_ir_extended
 	u8 yhi : 2;
 };
 
-struct wm_extension
+struct wm_nc_bt
+{
+	u8 z : 1; // buttons
+	u8 c : 1;
+	u8 axL : 2; // accelerometer
+	u8 ayL : 2;
+	u8 azL : 2;
+};
+
+struct wm_nc
 {
 	u8 jx; // joystick x, y
 	u8 jy;
 	u8 ax; // accelerometer
 	u8 ay;
 	u8 az;
-	u8 bt; // buttons
+	wm_nc_bt bt;
 };
 
 struct wm_classic_extension
@@ -147,25 +156,77 @@ struct wm_turntable_extension
 	};
 };
 
-struct wm_motionplus_data
+struct wm_nc_mp //nunchuk data on motion-plus pass-through
 {
-	u8 yaw1;
+	u8 jx;
+	u8 jy;
+	u8 ax;
+	u8 ay;
 
-	u8 roll1;
+	u8 extension_connected : 1; // 1 usually
+	u8 az : 7;
+	u8 dummy : 1; //0 always
 
+	u8 is_mp_data : 1; //0 when nunchuk interleaved data
+	u8 bz : 1;
+	u8 bc : 1;
+	u8 axL : 1; // ls 1, ls0 = 0 by default,
+	u8 ayL : 1;
+	u8 azL : 2;
+};
+
+struct wm_motionplus
+{
+	u8 yaw1;
+	u8 roll1;
 	u8 pitch1;
 
-	u8 yaw2 : 6;
-	u8 yaw_slow : 1;
 	u8 pitch_slow : 1;
+	u8 yaw_slow : 1;
+	u8 yaw2 : 6;
+	u8 extension_connected : 1;
 
-	u8 roll2 : 6;
 	u8 roll_slow : 1;
-	u8 extension_connected : 1;
+	u8 roll2 : 6;
+	u8 dummy : 1;
 
-	u8 pitch2 : 6;
 	u8 is_mp_data : 1;
-	u8 zero : 1;
+	u8 pitch2 : 6;
+};
+
+struct wm_motionplus_calibration
+{
+	u16 pitch : 14;
+	u8 : 2;
+	u16 roll : 14;
+	u8 : 2;
+	u16 yaw : 14;
+	u8 : 2;
+
+	u16 pitch_min : 14;
+	u8 : 2;
+	u16 pitch_max : 14;
+	u8 : 2;
+	u16 roll_min : 14;
+	u8 : 2;
+	u16 roll_max : 14;
+	u8 : 2;
+
+	u16 pitch_slow : 14;
+	u8 : 2;
+	u16 roll_slow  : 14;
+	u8 : 2;
+	u16 yaw_slow  : 14;
+	u8 : 2;
+
+	u16 pitch_min_slow : 14;
+	u8 : 2;
+	u16 pitch_max_slow : 14;
+	u8 : 2;
+	u16 roll_min_slow : 14;
+	u8 : 2;
+	u16 : 16;
+	u16 : 16;
 };
 
 struct wm_report
@@ -263,6 +324,11 @@ struct wm_read_data
 #define WM_SPACE_REGS2 2
 #define WM_SPACE_INVALID 3
 
+#define WIIMOTE_REG_SPEAKER 0xa2
+#define WIIMOTE_REG_EXT 0xa4
+#define WIIMOTE_REG_MP 0xa6
+#define WIIMOTE_REG_IR 0xb0
+
 #define WM_READ_DATA_REPLY 0x21
 struct wm_read_data_reply
 {
@@ -308,7 +374,7 @@ struct wm_report_core_accel_ext16
 {
 	wm_core c;
 	wm_accel a;
-	wm_extension ext;
+	wm_nc ext;
 	//wm_ir_basic ir[2];
 	u8 pad[10];
 
@@ -322,8 +388,7 @@ struct wm_report_core_accel_ir10_ext6
 	wm_core c;
 	wm_accel a;
 	wm_ir_basic ir[2];
-	//u8 ext[6];
-	wm_extension ext;
+	wm_nc ext;
 };
 
 #define WM_REPORT_EXT21 0x3d // never used?
@@ -356,17 +421,17 @@ struct accel_cal
 	struct
 	{
 		u8 x, y, z;
-		u8 xlo : 2;
-		u8 ylo : 2;
-		u8 zlo : 2;
+		u8 xL : 2;
+		u8 yL : 2;
+		u8 zL : 2;
 	} zero_g;
 
 	struct
 	{
 		u8 x, y, z;
-		u8 xlo : 2;
-		u8 ylo : 2;
-		u8 zlo : 2;
+		u8 xL : 2;
+		u8 yL : 2;
+		u8 zL : 2;
 	} one_g;
 };
 
diff --git a/Source/Core/Core/Src/HW/WiimoteReal/WiimoteReal.cpp b/Source/Core/Core/Src/HW/WiimoteReal/WiimoteReal.cpp
index ee6de5f..550cd22 100644
--- a/Source/Core/Core/Src/HW/WiimoteReal/WiimoteReal.cpp
+++ b/Source/Core/Core/Src/HW/WiimoteReal/WiimoteReal.cpp
@@ -293,8 +293,11 @@ void Wiimote::Update()
 
 	// Send the report
 	if (!rpt.empty() && m_channel > 0)
+	{
+		WiimoteEmu::Spy(NULL, rpt.data(), rpt.size());
 		Core::Callback_WiimoteInterruptChannel(index, m_channel,
 			rpt.data(), rpt.size());
+	}
 }
 
 void Wiimote::Prepare(int _index)
diff --git a/Source/Core/DolphinWX/Src/InputConfigDiagBitmaps.cpp b/Source/Core/DolphinWX/Src/InputConfigDiagBitmaps.cpp
index 6aa37d7..a0655f6 100644
--- a/Source/Core/DolphinWX/Src/InputConfigDiagBitmaps.cpp
+++ b/Source/Core/DolphinWX/Src/InputConfigDiagBitmaps.cpp
@@ -4,6 +4,8 @@
 
 #include "InputConfigDiag.h"
 #include "WxUtils.h"
+#include "Host.h"
+#include "../../Core/Src/Core.h"
 
 void InputConfigDialog::UpdateBitmaps(wxTimerEvent& WXUNUSED(event))
 {
@@ -17,12 +19,59 @@ void InputConfigDialog::UpdateBitmaps(wxTimerEvent& WXUNUSED(event))
 		return;
 
 	GamepadPage* const current_page = (GamepadPage*)m_pad_notebook->GetPage(m_pad_notebook->GetSelection());
+	static bool gyro_disabled;
+	static bool hide_ir;
 
 	std::vector< ControlGroupBox* >::iterator
 		g = current_page->control_groups.begin(),
 		ge = current_page->control_groups.end();
 	for ( ; g != ge; ++g  )
 	{
+		switch ( (*g)->control_group->type )
+		{
+		case GROUP_TYPE_OPTIONS :
+		{
+			gyro_disabled = (*g)->control_group->settings.size() > SETTING_MOTIONPLUS
+				&& (*g)->control_group->settings[SETTING_MOTIONPLUS]->value == 0;
+
+			hide_ir = (*g)->control_group->settings.size() > SETTING_IR_HIDE
+				&& (*g)->control_group->settings[SETTING_IR_HIDE]->value != 0;
+
+			// update ui
+			std::vector<ControllerEmu::ControlGroup::Setting*>::const_iterator
+				si = (*g)->control_group->settings.begin(),
+				se = (*g)->control_group->settings.end();
+			for (; si!=se; ++si)
+			{
+				(*si)->GetState();
+			}
+
+			std::vector<ControlButton*> cb = (*g)->control_buttons;
+			std::vector<ControlButton*>::const_iterator bi = (*g)->control_buttons.begin()
+				, be = (*g)->control_buttons.end();
+			for (int n = 0; bi!=be; ++bi, ++n)
+			{
+				(*bi)->Enable(!(gyro_disabled
+					&& n == SETTING_MOTIONPLUS_FAST));
+			}
+
+			std::vector<PadSetting*>::const_iterator
+				oi = (*g)->options.begin(),
+				oe = (*g)->options.end();
+			for (int n = 0; oi!=oe; ++oi, ++n)
+			{
+				if ((*oi)->wxcontrol->IsKindOf(CLASSINFO(wxCheckBox)))
+				{
+					(*oi)->wxcontrol->Enable(!(gyro_disabled
+						&& n == SETTING_MOTIONPLUS_FAST));
+					(*oi)->UpdateGUI();
+				}
+			}
+
+			break;
+		}
+		}
+
 		// if this control group has a bitmap
 		if ( (*g)->static_bitmap )
 		{
@@ -40,37 +89,40 @@ void InputConfigDialog::UpdateBitmaps(wxTimerEvent& WXUNUSED(event))
 
 			switch ( (*g)->control_group->type )
 			{
-			case GROUP_TYPE_TILT :
+
 			case GROUP_TYPE_STICK :
 			case GROUP_TYPE_CURSOR :
 				{
 					// this is starting to be a mess combining all these in one case
 
 					float x = 0, y = 0, z = 0;
-					float xx, yy;
+					float xx, yy, zz;
 
 					switch ((*g)->control_group->type)
 					{
 					case GROUP_TYPE_STICK :
 						((ControllerEmu::AnalogStick*)(*g)->control_group)->GetState( &x, &y, 32.0, 32-1.5 );
+
+						xx = (*g)->control_group->controls[C_RIGHT]->control_ref->State() - (*g)->control_group->controls[C_LEFT]->control_ref->State();
+						yy = (*g)->control_group->controls[C_DOWN]->control_ref->State() - (*g)->control_group->controls[C_UP]->control_ref->State();
+
+						xx *= 32 - 1; xx += 32;
+						yy *= 32 - 1; yy += 32;
 						break;
-					case GROUP_TYPE_TILT :
-						((ControllerEmu::Tilt*)(*g)->control_group)->GetState( &x, &y, 32.0, 32-1.5 );
-						break;
+
+					// read through Cursor::GetState instead of directly from State because that doesn't remove relative input from the emulation
 					case GROUP_TYPE_CURSOR :
-						((ControllerEmu::Cursor*)(*g)->control_group)->GetState( &x, &y, &z );
+						((ControllerEmu::Cursor*)(*g)->control_group)->GetState( &x, &y, &z, ((ControllerEmu::Cursor*)(*g)->control_group)->settings[C_RANGE]->value, true, false );
 						x *= (32-1.5); x+= 32;
 						y *= (32-1.5); y+= 32;
+
+						((ControllerEmu::Cursor*)(*g)->control_group)->GetState( &xx, &yy, &zz, 1.0, false, false );
+						xx *= (32-1.5); xx+= 32;
+						yy *= (32-1.5) * -1; yy+= 32;
+
 						break;
 					}
 
-					xx = (*g)->control_group->controls[3]->control_ref->State();
-					xx -= (*g)->control_group->controls[2]->control_ref->State();
-					yy = (*g)->control_group->controls[1]->control_ref->State();
-					yy -= (*g)->control_group->controls[0]->control_ref->State();
-					xx *= 32 - 1; xx += 32;
-					yy *= 32 - 1; yy += 32;
-
 					// draw the shit
 
 					// ir cursor forward movement
@@ -146,7 +198,7 @@ void InputConfigDialog::UpdateBitmaps(wxTimerEvent& WXUNUSED(event))
 					{
 						// deadzone circle
 						dc.SetBrush(*wxLIGHT_GREY_BRUSH);
-						dc.DrawCircle( 32, 32, ((*g)->control_group)->settings[SETTING_DEADZONE]->value * 32 );
+						dc.DrawCircle( 32, 32, ((*g)->control_group)->settings[AS_DEADZONE]->value * 32 );
 					}
 
 					// raw dot
@@ -157,6 +209,10 @@ void InputConfigDialog::UpdateBitmaps(wxTimerEvent& WXUNUSED(event))
 					//dc.DrawRectangle( xx-1, 64-yy-4, 2, 8 );
 					//dc.DrawRectangle( xx-4, 64-yy-1, 8, 2 );
 
+					if (hide_ir
+						&& (*g)->control_group->type == GROUP_TYPE_CURSOR)
+						break;
+
 					// adjusted dot
 					if (x!=32 || y!=32)
 					{
@@ -167,17 +223,56 @@ void InputConfigDialog::UpdateBitmaps(wxTimerEvent& WXUNUSED(event))
 						//dc.DrawRectangle( x-1, 64-y-4, 2, 8 );
 						//dc.DrawRectangle( x-4, 64-y-1, 8, 2 );
 					}
-
 				}
 				break;
 			case GROUP_TYPE_FORCE :
+			case GROUP_TYPE_TILT :
 				{
 					float raw_dot[3];
 					float adj_dot[3];
-					const float deadzone = 32 * ((*g)->control_group)->settings[0]->value;
+					float gyro_dot[3];
+					float deadzone;
 
 					// adjusted
-					((ControllerEmu::Force*)(*g)->control_group)->GetState( adj_dot, 32.0, 32-1.5 );
+					switch ((*g)->control_group->type)
+					{
+					case GROUP_TYPE_FORCE :
+						deadzone = 32 * ((*g)->control_group)->settings[F_DEADZONE]->value;
+						((ControllerEmu::Force*)(*g)->control_group)->GetState( adj_dot, 32.0, 32-1.5 );
+						break;
+
+					case GROUP_TYPE_TILT :
+						ControllerEmu::Tilt *cg = (ControllerEmu::Tilt*)(*g)->control_group;
+						bool has_gyro = cg->HasGyro();
+
+						deadzone = 32 * cg->settings[T_DEADZONE]->value;
+						cg->GetState( &(*adj_dot), &(*adj_dot)+1, &(*adj_dot)+2, false, 32.0, 32-1.5, !Core::IsRunning() );
+						if (cg->HasGyro())
+							cg->GetState( &(*gyro_dot), &(*gyro_dot)+1, &(*gyro_dot)+2, true, 32.0, 32-1.5, !Core::IsRunning() );
+
+						// update ui
+						std::vector<ControlButton*>::const_iterator bi = (*g)->control_buttons.begin()
+							, be = (*g)->control_buttons.end();
+						for (int n = 0; bi!=be; ++bi, ++n)
+						{
+							(*bi)->Enable(!(has_gyro
+							&& gyro_disabled
+							&& (n == T_FAST
+							|| n == T_GYRO_RANGE_1
+							|| n == T_GYRO_RANGE_2)));
+						}
+
+						std::vector<PadSetting*>::const_iterator si = (*g)->options.begin()
+							, se = (*g)->options.end();
+						for (int n = 0; si!=se; ++si, ++n)
+						{
+							(*si)->wxcontrol->Enable(!(has_gyro
+							&& gyro_disabled
+							&& (n == T_GYRO_RANGE
+							|| n == T_GYRO_SETTLE)));
+						}
+						break;
+					}
 
 					// raw
 					for ( unsigned int i=0; i<3; ++i )
@@ -204,6 +299,15 @@ void InputConfigDialog::UpdateBitmaps(wxTimerEvent& WXUNUSED(event))
 						dc.SetBrush(*wxRED_BRUSH);
 						dc.DrawRectangle( 0, adj_dot[2] - 1, 64, 2 );
 					}
+					if ( (*g)->control_group->type == GROUP_TYPE_TILT )
+					{
+						if ( ((ControllerEmu::Tilt*)(*g)->control_group)->HasGyro() )
+						{
+							dc.SetPen(*wxBLUE_PEN);
+							dc.SetBrush(*wxBLUE_BRUSH);
+							dc.DrawRectangle( 0, gyro_dot[2], 64, 1 );
+						}
+					}
 
 					// a rectangle, for looks i guess
 					dc.SetBrush(*wxWHITE_BRUSH);
@@ -226,6 +330,15 @@ void InputConfigDialog::UpdateBitmaps(wxTimerEvent& WXUNUSED(event))
 						dc.SetBrush(*wxRED_BRUSH);
 						dc.DrawRectangle( adj_dot[1]-2, adj_dot[0]-2, 4, 4 );
 					}
+					if ( (*g)->control_group->type == GROUP_TYPE_TILT )
+					{
+						if ( ((ControllerEmu::Tilt*)(*g)->control_group)->HasGyro() )
+						{
+							dc.SetPen(*wxBLUE_PEN);
+							dc.SetBrush(*wxBLUE_BRUSH);
+							dc.DrawRectangle( gyro_dot[1] - 1, gyro_dot[0]-  1, 2, 2 );
+						}
+					}
 
 				}
 				break;
@@ -263,7 +376,7 @@ void InputConfigDialog::UpdateBitmaps(wxTimerEvent& WXUNUSED(event))
 					}
 
 					delete[] bitmasks;
-					
+
 				}
 				break;
 			case GROUP_TYPE_TRIGGERS :
diff --git a/Source/Core/InputCommon/Src/ControllerEmu.cpp b/Source/Core/InputCommon/Src/ControllerEmu.cpp
index 328fcb8..76c5e2e 100644
--- a/Source/Core/InputCommon/Src/ControllerEmu.cpp
+++ b/Source/Core/InputCommon/Src/ControllerEmu.cpp
@@ -3,6 +3,7 @@
 // Refer to the license.txt file included.
 
 #include "ControllerEmu.h"
+#include "../../Core/Src/Core.h"
 
 #if defined(HAVE_X11) && HAVE_X11
 #include <X11/Xlib.h>
@@ -62,6 +63,12 @@ void ControllerEmu::UpdateReferences(ControllerInterface& devi)
 		for (; ci!=ce; ++ci)
 			devi.UpdateReference((*ci)->control_ref, default_device);
 
+		std::vector<ControlGroup::Setting*>::const_iterator
+			si = (*i)->settings.begin(),
+			se = (*i)->settings.end();
+		for (; si!=se; ++si)
+			devi.UpdateReference((*si)->control->control_ref, default_device);
+
 		// extension
 		if (GROUP_TYPE_EXTENSION == (*i)->type)
 		{
@@ -114,6 +121,7 @@ void ControllerEmu::ControlGroup::LoadConfig(IniFile::Section *sec, const std::s
 	{
 		sec->Get((group+(*si)->name).c_str(), &(*si)->value, (*si)->default_value*100);
 		(*si)->value /= 100;
+		sec->Get((group+(*si)->name+"/Input").c_str(), &(*si)->control->control_ref->expression, "");
 	}
 
 	// controls
@@ -178,7 +186,10 @@ void ControllerEmu::ControlGroup::SaveConfig(IniFile::Section *sec, const std::s
 		si = settings.begin(),
 		se = settings.end();
 	for (; si!=se; ++si)
+	{
 		sec->Set((group+(*si)->name).c_str(), (*si)->value*100.0f, (*si)->default_value*100.0f);
+		sec->Set((group+(*si)->name+"/Input").c_str(), (*si)->control->control_ref->expression, "");
+	}
 
 	// controls
 	std::vector<ControlGroup::Control*>::const_iterator
@@ -219,6 +230,22 @@ void ControllerEmu::SaveConfig(IniFile::Section *sec, const std::string& base)
 		(*i)->SaveConfig(sec, defdev, base);
 }
 
+void ControllerEmu::ControlGroup::Setting::GetState()
+{
+	bool state = control->control_ref->State() ? true : false;
+
+	if (state == lastState)
+		return;
+	lastState = state;
+
+	if (!state)
+		return;
+
+	value = !value;
+
+	Core::DisplayMessage(StringFromFormat("%s: %s", name, value ? "Enabled" : "Disabled").c_str(), 2000);
+}
+
 ControllerEmu::AnalogStick::AnalogStick(const char* const _name) : ControlGroup(_name, GROUP_TYPE_STICK)
 {
 	for (unsigned int i = 0; i < 4; ++i)
@@ -232,8 +259,10 @@ ControllerEmu::AnalogStick::AnalogStick(const char* const _name) : ControlGroup(
 
 }
 
-ControllerEmu::Buttons::Buttons(const char* const _name) : ControlGroup(_name, GROUP_TYPE_BUTTONS)
+ControllerEmu::Buttons::Buttons(const char* const _name, bool has_range) : m_has_range(has_range), ControlGroup(_name, GROUP_TYPE_BUTTONS)
 {
+	if (has_range)
+		settings.push_back(new Setting(_trans("Range"), 1.0f, 0, 500));
 	settings.push_back(new Setting(_trans("Threshold"), 0.5f));
 }
 
@@ -258,6 +287,7 @@ ControllerEmu::Slider::Slider(const char* const _name) : ControlGroup(_name, GRO
 ControllerEmu::Force::Force(const char* const _name) : ControlGroup(_name, GROUP_TYPE_FORCE)
 {
 	memset(m_swing, 0, sizeof(m_swing));
+	memset(m_state, 0, sizeof(m_state));
 
 	controls.push_back(new Input(_trans("Up")));
 	controls.push_back(new Input(_trans("Down")));
@@ -266,21 +296,40 @@ ControllerEmu::Force::Force(const char* const _name) : ControlGroup(_name, GROUP
 	controls.push_back(new Input(_trans("Forward")));
 	controls.push_back(new Input(_trans("Backward")));
 
+	settings.push_back(new Setting(_trans("Range"), 1.0f, 0, 500));
 	settings.push_back(new Setting(_trans("Dead Zone"), 0, 0, 50));
 }
 
-ControllerEmu::Tilt::Tilt(const char* const _name)
-	: ControlGroup(_name, GROUP_TYPE_TILT)
+ControllerEmu::Tilt::Tilt(const char* const _name, bool gyro)
+	: m_has_gyro(gyro)
+	, ControlGroup(_name, GROUP_TYPE_TILT)
 {
-	memset(m_tilt, 0, sizeof(m_tilt));
+	memset(m_acc, 0, sizeof(m_acc));
+	memset(m_gyro, 0, sizeof(m_gyro));
+	memset(m_settle, 0, sizeof(m_settle));
 
 	controls.push_back(new Input("Forward"));
 	controls.push_back(new Input("Backward"));
 	controls.push_back(new Input("Left"));
 	controls.push_back(new Input("Right"));
+	controls.push_back(new Input("Yaw Left"));
+	controls.push_back(new Input("Yaw Right"));
 
-	controls.push_back(new Input(_trans("Modifier")));
-
+	if (gyro)
+	{
+		controls.push_back(new Input(_trans("Fast")));
+		controls.push_back(new Input(_trans("Acc Range")));
+		controls.push_back(new Input(_trans("Gyro Range 1")));
+		controls.push_back(new Input(_trans("Gyro Range 2")));
+		settings.push_back(new Setting(_trans("Acc Range"), 1.0f, 0, 500));
+		settings.push_back(new Setting(_trans("Gyro Range"), 1.0f, 0, 500));
+		settings.push_back(new Setting(_trans("Gyro Settle"), 0.25f, 0, 9999));
+	}
+	else
+	{
+		controls.push_back(new Input(_trans("Range")));
+		settings.push_back(new Setting(_trans("Range"), 1.0f, 0, 500));
+	}
 	settings.push_back(new Setting(_trans("Dead Zone"), 0, 0, 50));
 	settings.push_back(new Setting(_trans("Circle Stick"), 0));
 	settings.push_back(new Setting(_trans("Angle"), 0.9f, 0, 180));
@@ -288,18 +337,23 @@ ControllerEmu::Tilt::Tilt(const char* const _name)
 
 ControllerEmu::Cursor::Cursor(const char* const _name)
 	: ControlGroup(_name, GROUP_TYPE_CURSOR)
-	, m_z(0)
 {
+	memset(m_state, 0, sizeof(m_state));
+	memset(m_absolute, 0, sizeof(m_absolute));
+	memset(m_last, 0, sizeof(m_last));
+
 	for (unsigned int i = 0; i < 4; ++i)
 		controls.push_back(new Input(named_directions[i]));
 	controls.push_back(new Input("Forward"));
 	controls.push_back(new Input("Backward"));
+	controls.push_back(new Input(_trans("Range")));
 	controls.push_back(new Input(_trans("Hide")));
+	controls.push_back(new Input(_trans("Show")));
 
+	settings.push_back(new Setting(_trans("Range"), 1.0f, 0, 500));
 	settings.push_back(new Setting(_trans("Center"), 0.5f));
 	settings.push_back(new Setting(_trans("Width"), 0.5f));
 	settings.push_back(new Setting(_trans("Height"), 0.5f));
-
 }
 
 void ControllerEmu::LoadDefaults(const ControllerInterface &ciface)
